module Alimento

	class MenuDSL
	
		attr_reader :nombre, :descripcion_menu, :componentes_menu, :precios, :precio_total

		def initialize(nombre, &block)
			@nombre = nombre
			@componentes_menu = []
			@precios = []
			@descripcion_menu = ""
			@precio_total
		
			if block_given?
				if block.arity == 1
					yield self
				else
					instance_eval(&block)
				end
			end
		end
		
		
		def descripcion(descr)
			@descripcion_menu = descr
		end


		def componente(options = {})
			@componentes_menu << options[:platito] if options[:platito]
			@precios << options[:precio] if options[:precio]
		end

		
		def precio(coste)
			@precio_total = coste
		end


		def to_s
    
			output = "Nombre de menu: #{@nombre}"
			output += "\nPlatos:"
			@componentes_menu.each {|iter| 
				if iter.platito == nil
					iter.platillo()
				end
				
				output += "\n\n\tTipo: #{iter.platito.nombre}" 
    		output += "\n\tValor Nutricional: #{iter.platito.VCT()}"
				output += "\n\tValor Ambiental: #{iter.platito.emisiones_total()}"
			}
		output += "\n\nPrecio menú: #{@precio_total}"
    output
  	end
	
	end

end
