module Alimento

	class PlatoDSL

		require "alimento"
		
		attr_reader :nombre, :descripcion_plato, :componentes, :gramos, :alimentos, :platito

		def initialize(nombre, &block)
			@nombre = nombre
			@componentes = []
			@gramos = []
			@platito
			@list 
			if block_given?
				if block.arity == 1
					yield self
				else
					instance_eval(&block)
				end
			end
		end
	
		def descripcion(descr)
			@descripcion_plato = descr
		end

		def alimento(options = {})
			@componentes << options[:alimento]
			@gramos << options[:gramos] if options[:gramos]
		end

		def platillo
			@list = List.new(@componentes[0])
			for i in (1..@componentes.length - 1)
				@list.insert_head(@componentes[i])
			end
			@platito = PlatoAmbiental.new(@nombre, @list, @gramos)
		end

		def to_s
			if @platillo == nil
				platillo()
			end
			i = 0
			aux = "Nombre: #{@nombre}"
			aux += "\nComponentes: "
			@componentes.each { |val| 
					aux += "\n\t#{val.nombre}"
					aux += "\n\tGramos: #{@gramos[i]}"
					i += 1
			}
			aux
		end	
	end
end
